




@mixin menu-link-arrow-rotate($angle, $angleRtl) {
  transform: rotateZ($angle) #{'/*rtl:ignore*/'};
  transition: get($menu, accordion, arrow-transition);

  [direction='rtl'] & {
    transform: rotateZ($angleRtl) #{'/*rtl:ignore*/'};
  }
}


@mixin menu-link-padding-x($value) {
  
  .menu-item {
    .menu-link,
    .menu-content {
      padding-left: $value;
      padding-right: $value;
    }
  }
}


@mixin menu-link-padding-y($value) {
  
  .menu-item {
    .menu-link,
    .menu-content {
      padding-top: $value;
      padding-bottom: $value;
    }
  }
}


@mixin menu-link-indention($value, $offset) {
  
  .menu-sub:not([data-popper-placement]) {
    > .menu-item {
      > .menu-content,
      > .menu-link {
        padding-left: calc(#{1 * $value} + #{$offset});
      }

      > .menu-sub:not([data-popper-placement]) {
        > .menu-item {
          > .menu-content,
          > .menu-link {
            padding-left: calc(#{2 * $value} + #{$offset});
          }

          > .menu-sub:not([data-popper-placement]) {
            > .menu-item {
              > .menu-content,
              > .menu-link {
                padding-left: calc(#{3 * $value} + #{$offset});
              }

              > .menu-sub:not([data-popper-placement]) {
                > .menu-item {
                  > .menu-content,
                  > .menu-link {
                    padding-left: calc(#{4 * $value} + #{$offset});
                  }
                }
              }
            }
          }
        }
      }
    }

    .menu-fit & {
      > .menu-item {
        > .menu-content,
        > .menu-link {
          padding-left: #{$value};
          padding-right: 0;
        }

        > .menu-sub:not([data-popper-placement]) {
          > .menu-item {
            > .menu-content,
            > .menu-link {
              padding-left: calc(#{2 * $value});
              padding-right: 0;
            }

            > .menu-sub:not([data-popper-placement]) {
              > .menu-item {
                > .menu-content,
                > .menu-link {
                  padding-left: calc(#{3 * $value});
                  padding-right: 0;
                }

                > .menu-sub:not([data-popper-placement]) {
                  > .menu-item {
                    > .menu-content,
                    > .menu-link {
                      padding-left: calc(#{4 * $value});
                      padding-right: 0;
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}


@mixin menu-link-theme($title-color, $icon-color, $bullet-color, $arrow-color, $bg-color: null) {
  @if ($bg-color != null) {
    background-color: $bg-color;
  }

  @if ($title-color != null) {
    color: $title-color;

    .menu-title {
      color: #ffffff;
    }
  }

  @if ($icon-color != null) {
    .menu-icon {
      
      i {
        color: $icon-color;
      }

      
      .svg-icon {
        @include svg-icon-color(#ffffff);
      }
    }
  }

  @if ($bullet-color != null) {
    .menu-bullet {
      .bullet {
        background-color: $bullet-color;
      }
    }
  }

  @if ($arrow-color != null) {
    
    .menu-arrow:after {
      @include svg-bg-icon(arrow-end, $arrow-color);
    }
  }
}


@mixin menu-link-default-state(
  $title-color,
  $icon-color,
  $bullet-color,
  $arrow-color,
  $bg-color: null,
  $all-links: true
) {
  $sel: '';

  @if ($all-links == false) {
    $sel: '& > ';
  }

  #{$sel}.menu-link {
    @include menu-link-theme($title-color, $icon-color, $bullet-color, $arrow-color, $bg-color);
  }
}


@mixin menu-link-hover-state(
  $title-color,
  $icon-color,
  $bullet-color,
  $arrow-color,
  $bg-color: null,
  $all-links: true
) {
  $sel: '';

  @if ($all-links == false) {
    $sel: '& > ';
  }

  &.hover > .menu-link:not(.disabled):not(.active),
  #{$sel}.menu-link:hover:not(.disabled):not(.active) {
    transition: $transition-link;

    @include menu-link-theme($title-color, $icon-color, $bullet-color, $arrow-color, $bg-color);
  }
}


@mixin menu-link-active-state(
  $title-color,
  $icon-color,
  $bullet-color,
  $arrow-color,
  $bg-color: null,
  $all-links: true
) {
  $sel: '';

  @if ($all-links == false) {
    $sel: '& > ';
  }

  #{$sel}.menu-link.active {
    transition: $transition-link;

    @include menu-link-theme($title-color, $icon-color, $bullet-color, $arrow-color, $bg-color);
  }
}


@mixin menu-link-show-state(
  $title-color,
  $icon-color,
  $bullet-color,
  $arrow-color,
  $bg-color: null,
  $all-links: true
) {
  &.here > .menu-link,
  &.show > .menu-link {
    transition: $transition-link;

    @include menu-link-theme($title-color, $icon-color, $bullet-color, $arrow-color, $bg-color);
  }
}


@mixin menu-link-here-state(
  $title-color,
  $icon-color,
  $bullet-color,
  $arrow-color,
  $bg-color: null,
  $all-links: true
) {
  &.here > .menu-link {
    transition: $transition-link;

    @include menu-link-theme($title-color, $icon-color, $bullet-color, $arrow-color, $bg-color);
  }
}
